
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Kpi_definitionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const kpi_definitions = await db.kpi_definitions.create(
            {
                id: data.id || undefined,
        
        kpi_name: data.kpi_name
        ||
        null
            ,
            
        kpi_key: data.kpi_key
        ||
        null
            ,
            
        unit: data.unit
        ||
        null
            ,
            
        direction: data.direction
        ||
        null
            ,
            
        target_value: data.target_value
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await kpi_definitions.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        

        

        

        return kpi_definitions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const kpi_definitionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                kpi_name: item.kpi_name
            ||
            null
            ,
            
                kpi_key: item.kpi_key
            ||
            null
            ,
            
                unit: item.unit
            ||
            null
            ,
            
                direction: item.direction
            ||
            null
            ,
            
                target_value: item.target_value
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const kpi_definitions = await db.kpi_definitions.bulkCreate(kpi_definitionsData, { transaction });

        // For each item created, replace relation files
        

        return kpi_definitions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const kpi_definitions = await db.kpi_definitions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.kpi_name !== undefined) updatePayload.kpi_name = data.kpi_name;
        
        
        if (data.kpi_key !== undefined) updatePayload.kpi_key = data.kpi_key;
        
        
        if (data.unit !== undefined) updatePayload.unit = data.unit;
        
        
        if (data.direction !== undefined) updatePayload.direction = data.direction;
        
        
        if (data.target_value !== undefined) updatePayload.target_value = data.target_value;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await kpi_definitions.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await kpi_definitions.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        

        
        

        

        return kpi_definitions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const kpi_definitions = await db.kpi_definitions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of kpi_definitions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of kpi_definitions) {
                await record.destroy({transaction});
            }
        });


        return kpi_definitions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const kpi_definitions = await db.kpi_definitions.findByPk(id, options);

        await kpi_definitions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await kpi_definitions.destroy({
            transaction
        });

        return kpi_definitions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const kpi_definitions = await db.kpi_definitions.findOne(
            { where },
            { transaction },
        );

        if (!kpi_definitions) {
            return kpi_definitions;
        }

        const output = kpi_definitions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.kpi_measurements_kpi_definition = await kpi_definitions.getKpi_measurements_kpi_definition({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await kpi_definitions.getOrganization({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.kpi_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'kpi_definitions',
                        'kpi_name',
                        filter.kpi_name,
                    ),
                };
            }
            
            if (filter.kpi_key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'kpi_definitions',
                        'kpi_key',
                        filter.kpi_key,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'kpi_definitions',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.target_valueRange) {
                const [start, end] = filter.target_valueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    target_value: {
                    ...where.target_value,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    target_value: {
                    ...where.target_value,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.unit) {
                where = {
                    ...where,
                unit: filter.unit,
            };
            }
            
            if (filter.direction) {
                where = {
                    ...where,
                direction: filter.direction,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.kpi_definitions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'kpi_definitions',
                        'kpi_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.kpi_definitions.findAll({
            attributes: [ 'id', 'kpi_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['kpi_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.kpi_name,
        }));
    }

    
};

